//+------------------------------------------------------------------+
//|                                                   iMZFF_v010.mq4 |
//|                                         Copyright  2009, Camper |
//|                                        http://www.aboutcamper.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Camper"
#property link      "http://www.aboutcamper.ru"

#property indicator_chart_window
//    
#property indicator_buffers  7
#property indicator_color1 CLR_NONE
#property indicator_color2 CLR_NONE
#property indicator_color4 White
#property indicator_color5 Aqua
#property indicator_color6 Yellow
#property indicator_color7 Red

#import "stdlib.ex4"
string ErrorDescription(int error_code);
// external libraries
#include <indicators.mqh>
#include <cmdfunc.mqh>
#include <cmdfibos.mqh>
//#include <myservice.mqh>

//     
extern int minTrendLen=1;						//      
extern int zzPeriod=5;							//   
extern int backStep=10;							//  ,         
extern int minPoints=0;							//      0  100 
extern string outputType="f";					// f:  , p -   
extern string defineTrendBy="zz";			//    : zz - , sar - Parabolic SAR
extern bool drawObjects=true;					//      (, .. )
extern bool showDebug=false;

extern int spPriceType		= 13;				//     : 
														// 0 - (H+L+C+O)/4
														// 1 - ; 2 - ; 3 - ; 4 - ;
														// 5 - (H + L)/2; 6 - (H+L+C)/3; 7 - (H+L+C+O)/4; 8 - (H+L+C+C)/4;
														// 9 - MA
														// 11 - Acc&MA
														// 12 - Acc&LR
														// 13 - Acc&LR&ZZ
int maxBars=2500;									//       
string s2="===   Acc&LR  1 ===";
int LRPeriod=1;
int LRPrice=0;
int LRzzPeriod=5;
string s3="==========================================";


//  
double openFiboLevel=0.5;						//  ,    
double closeFiboLevel=0.8;						//  ,    
int fiboCount=40;									//    
int fiboRedrawCount=1;							//  ,      .


// 
int fiboIndex[];																			//    ,    
double fiboZeroLevel[], fiboFullLevel[], openPrice[], closePrice[];		//     / 
double level0[], level23[], level100[], level161[], level261[];
double sp[], ac[];																		//   
double zzM1[], zzM1H[], zzM1L[];														//   1
int lastTrend=-1;																			//   .   : OP_BUY  ...
int lastTrendStart=-1;																	//  ,     
int lastExtremumBar=-1;																// ,     
double lastExtremum=0;
bool watchAccChange=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
//---- indicators
	SetIndexBuffer(0, fiboZeroLevel);
	SetIndexBuffer(1, fiboFullLevel);
	SetIndexBuffer(2, level0);
	SetIndexBuffer(3, level23);
	SetIndexBuffer(4, level100);
	SetIndexBuffer(5, level161);
	SetIndexBuffer(6, level261);
//   ,      
	SetIndexEmptyValue(2,0.0);
	SetIndexEmptyValue(3,0.0);
	SetIndexEmptyValue(4,0.0);
	SetIndexEmptyValue(5,0.0);
	SetIndexEmptyValue(6,0.0);

	//SetIndexStyle(0,DRAW_ARROW, EMPTY, 0, White);
	SetIndexStyle(3,DRAW_ARROW);
	SetIndexStyle(4,DRAW_ARROW);
	SetIndexStyle(5,DRAW_ARROW);
	SetIndexStyle(6,DRAW_ARROW);

	ArrayResize(sp, maxBars);
	ArrayResize(ac, maxBars);
	ArrayResize(zzM1, maxBars);
	ArrayResize(zzM1L, maxBars);
	ArrayResize(zzM1H, maxBars);
	ArrayResize(fiboIndex, maxBars);
	
	ArrayInitialize(fiboZeroLevel, 0.0);
	ArrayInitialize(fiboFullLevel, 0.0);
	
	zzPeriod=zzPeriod*Period();
	LRzzPeriod=zzPeriod;

	lastTrendStart=maxBars;
	lastExtremumBar=maxBars;
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
//----
	deleteObjects();
//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
	int counted_bars=IndicatorCounted();
	int limit=Bars-counted_bars;
	if(limit>maxBars)limit=maxBars;
//----
	defineNewBar();
	//    ,     
	if(is_newbar)processNewBar(counted_bars);
	findPoints(limit+backStep,Period());
//----
	return(0);
}
//   :
// 1.  
// 2.    (1)
//
//     fromBar,      
double findPoints(int fromBar, int tf){
	//        1,     
	// ,     
	double fibo23, fibo0, fibo100;
	string temp="";
	int index=convertBarNo(fromBar,PERIOD_M1,tf);
	while(index>0){
		fiboZeroLevel[index]=0;
		fiboFullLevel[index]=0;
		//     
		index=getNewExtremumBar(index-1);
		double newExtremum=getZZValue(index);
		//Print("Extremum on bar "+index+" is "+newExtremum);
		//if(newExtremum!=lastExtremum && temp-lastExtremumBar<zzPeriod)deleteLastFibo(fi);
		
		if(newExtremum==0){
			if(showDebug)Print("Error: no extremum found");
			index--;
		}else{
			lastTrendStart=index;
			if(newExtremum<lastExtremum)lastTrend=OP_BUY;
			else lastTrend=OP_SELL;
			lastExtremum=newExtremum;
			//       23
			//Print("Watching ACC");
			//        
			int stopBarM1=getStopBar(lastTrendStart, lastTrend);
			if(stopBarM1>0){
				// ,    
				//     
				int fiboBar=convertBarNo(lastTrendStart,tf,PERIOD_M1);
				//Print("Fibo needed at "+fiboBar);
				// ,    
				if(fiboZeroLevel[fiboBar]!=0){
					//Print("no data: "+fiboBar);
					continue;
				}
				temp="["+TimeToStr(iTime(NULL,PERIOD_M1,lastTrendStart))+"] ";
				if(lastTrend==OP_BUY)temp=temp+" BUY, ";
				else temp=temp+" SELL, ";
				temp=temp+"start="+lastTrendStart+", stop="+stopBarM1+", ";

				fibo0=lastExtremum;
				fibo100=calcSecondPrice(stopBarM1,fibo0,tf);	//  100%
				//fibo100=calcSecondPrice(stopBar,fibo0,tf,true);	//  100%
				//Print("Stop bar #"+stopBarM1+" between "+lastTrendStart+" and "+(lastTrendStart-1)+"): "+fibo100);
			
				//  
				if(minPoints>0 && minPoints>MathAbs((fibo100-fibo0)/Point)){
					continue;
				}
			
				fibo23=fibo0+(fibo100-fibo0)*fiboSecondLevel;
				// ??  ,    23%     (  )
				//if(fibo23>iHigh(NULL,tf,stopBar) || fibo23<iLow(NULL,tf,stopBar)){
					//Print("extremum="+fibo0+" (bar "+lastExtremumBar+"), price0="+fibo0+", price100="+fibo100+" on "+stopBar+" bar ("+stopBarM1+")");
				//}
				
				fiboZeroLevel[fiboBar]=fibo0;
				fiboFullLevel[fiboBar]=fibo100;
				int stopBar=convertBarNo(stopBarM1,tf,PERIOD_M1);
				//stopBarA[fiboBar]=""+stopBar+"("+stopBarM1+")";
				temp=temp+"0="+fibo0+", 100="+fibo100+", this TF: time="+TimeToStr(Time[fiboBar])+", bar="+fiboBar;
				//if(showDebug)if(index<250&&index>0)Print(temp);
			
				//        
				if(drawObjects && fiboIndex[fiboBar]==0 && fiboIndex[fiboBar+1]==0){
					//Print("Draw fibo on "+fiboBar+" from "+fibo0+" to "+fibo100+", fiboindex = "+fiboIndex[fiboBar]);
					if(outputType=="f"){
						drawFibo(fiboBar, fiboBar, fiboZeroLevel[fiboBar], fiboFullLevel[fiboBar]);
					  	fiboIndex[fiboBar]=fiboBar;
					}
					else if(outputType=="p"){
						//  3   
						drawFiboPoints(fiboBar, fibo0, fibo100, 4, tf);
					}
				}
				
			}else{
				//Print("no stop found for "+lastExtremumBar+" ("+TimeToStr(Time[lastExtremumBar])+")");
			}
		}
	}
}
//      
//            0 
//       lastExtremumBar
// TODO:   ,      
double getNewExtremumBar(int from){
	//Print("searching extremum from "+from+" to "+to);
	double newExtremum=0;
	int index=from;
	//     ,     ,   
	while(newExtremum==0 && index>0){
		index--;
		//   
		newExtremum=getZZValue(index);
	}
	if(newExtremum!=0){
		//Print("Found extr on ZZ "+newExtremum+", index = "+index);
		//      ?
		double v;
		int direction;
		if(newExtremum>lastExtremum)direction=OP_SELL;
		else direction=OP_BUY;
		for(int i=index-1; i>index-10; i--){
			//     
			if(i>0){
				if(direction==OP_BUY)v=Low[i];
				else v=High[i];
				if(v==newExtremum)index=i;
			}else break;
		}
		return(index);
	}//else Print("not found");
	
	return(0);
}
//   ,    
//     
//     
//   ,    - 
//   .      ,  
//    ,   - !
// ---
//      ,   ,    
// ,   
// from     ,     ,   1!!!
int getStopBar(int from, int direction){
	return(getStopByAcc(from,direction));
	//return(getStopByZZ(from,direction));
}
int getStopByAcc(int from, int direction){
	int result=0;
	int to=0;
	//Print("Searching stop from "+from+" to "+to);
	for(int i=from; i>to; i--){
		//       !
		//if((direction==OP_BUY && Low[i]>lastExtremum) || (direction==OP_SELL && High[i]<lastExtremum))continue;
		//sp[i]=calcSpeed(i)/Point;
		//      
		ac[i]=calcAcceleration(i,Period());
		if(i==from)continue;	//       
		//     
		if(direction==OP_BUY){
			//    
			if(ac[i+1]>ac[i]){
			//if((ac[i+1]>=0 && ac[i]<=0)){
				result=i+1;
				break;
			}
		}
		else if(direction==OP_SELL){
			if(ac[i+1]<ac[i]){
			//if((ac[i+1]<=0 && ac[i]>=0)){
				result=i+1;
				break;
			}
		}
	}
	return(result);
}
//     ,  1 (!)
// recalc: true:   , false:      ,
//			        1 (!)
double calcSecondPrice(int barNo, double fibo0, int tf, bool recalc=false){
	int minutes=Period();	//     
	double acc0, acc1, price;		//      
	
	if(recalc==false){
		//      fiboSecondLevel...
		price=getAngleMAValue(barNo,PERIOD_M1);
		//if(lastTrend==OP_BUY)price=iHigh(NULL,tf,convertBarNo(barNo,tf,PERIOD_M1));
		//else price=iLow(NULL,PERIOD_M1,convertBarNo(barNo,tf,PERIOD_M1));
		// ...       100%,     
		if(barNo>520 && barNo<1500){
			//if(price>High[barNo] || price<Low[barNo])Print("Fucked up ("+TimeToStr(iTime(NULL, PERIOD_M1, barNo))+" / "+barNo+" / "+(barNo)+"):"+price);
			//else Print("In place ("+TimeToStr(Time[barNo])+" / "+barNo+")");
			//Print(TimeToStr(iTime(NULL, PERIOD_M1, barNo))+":"+(barNo)+":"+getAngleMAValue(barNo+1,PERIOD_M1)+", "+getAngleMAValue(barNo,PERIOD_M1)+", "+
			//	getAngleMAValue(barNo-1,PERIOD_M1));
		}
		price=(price-fibo0)/fiboSecondLevel+fibo0;
		return(price);
	}
	//  
	for(int i=minutes-1; i>=0; i--){
		acc0=calcAcceleration(barNo*minutes+i-1);
		acc1=calcAcceleration(barNo*minutes+i);
		if((acc1>=0 && acc0<=0) || (acc1<=0 && acc0>=0)){
			//      fiboSecondLevel...
			//price=iMA(NULL,PERIOD_M1,20,0,MODE_LWMA,PRICE_CLOSE,i+barNo*minutes);
			price=getAngleMAValue(barNo*minutes+i-1,PERIOD_M1);	// !     iTime()
			//if(price>High[barNo] || price<Low[barNo])Print("Fucked up ("+barNo+" / "+(i+barNo*minutes)+"):"+price);
			//else Print("In place ("+barNo+")");
			// ...       100%,     
			price=(price-fibo0)/fiboSecondLevel+fibo0;
			return(price);
		}
	}
}
//      barNo
//     : OP_BUY  , OP_SELL  
int getCurrentTrend(int barNo){
	if(defineTrendBy=="sar")return(calcTrendSAR(barNo));
	if(defineTrendBy=="zz")return(calcTrendZZ(barNo));
}
int calcTrendZZ(int barNo){
	//  ZZ,   zzPeriod ,   zzPeriod    
	double v;
	int result=-1;
	for(int i=barNo; i<=barNo+zzPeriod; i++){
		v=iCustom(NULL,0,"DT_ZZ_optimized",zzPeriod,2,0,i);
		if(v!=0){
			if(v==High[i])result=OP_SELL;		//    -  
			else if(v==Low[i])result=OP_BUY;	//    -  
			//      ,    
			lastTrendStart=i;
			//Print("Found new trend: bar="+i+", trend="+result);
			break;
		}
	}
	return(result);
}
//      Parabolic SAR
int calcTrendSAR(int barNo){
	//  Parabolic SAR,       
	double v=iSAR(NULL, 0, 0.02, 0.2, barNo);
	int result=-1, temp=-1;
	if(v>High[barNo])result=OP_SELL;		//    -  
	else if(v<Low[barNo])result=OP_BUY;	//    -  
	if(result!=lastTrend){
		//      ,    
		//     
		for(int i=barNo+1; i<lastTrendStart; i++){
			v=iSAR(NULL, 0, 0.02, 0.2, i);
			if(v>High[i])temp=OP_SELL;		//    -  
			else if(v<Low[i])temp=OP_BUY;	//    -  
			if(temp!=result){
				lastTrendStart=i-1;
				break;
			}
		}
	}
	return(result);
}
//        
//  levels ,   23% (3 -> 23%, 100%, 161%, 4 -   + 261%)
void drawFiboPoints(int barNo, double fibo0, double fibo100, int levels=4, int tf=0){
	double delta=fibo100-fibo0;
	double v;
	int fi;
	//     3 ,   - 1   - 5
	if(tf==Period() || tf==0)fi=3;
	else if(tf<Period())fi=1;
	else fi=5;
	barNo--;
	for(int j=barNo; j>barNo-fi; j--){
		level0[j]=fibo0;
		for(int i=0; i<levels; i++){
			if(i==0){
				v=fibo0+(delta)*fiboSecondLevel;
			}else{
				v=fibo0+(delta)*fiboLevel[i-1];
			}
			switch(i){
				case 0: level23[j]=v; break;
				case 1: level100[j]=v; break;
				case 2: level161[j]=v; break;
				case 3: level261[j]=v; break;
			}
		}
	}
}
//    1
double calcSpeed(int barNo){
	int tf=PERIOD_M1;
	switch(spPriceType){
		case 1:
			return(iOpen(NULL,tf,barNo)-iOpen(NULL,tf,barNo+1));
		case 2:
			return(iClose(NULL,tf,barNo)-iClose(NULL,tf,barNo+1));
		case 3:
			return(iHigh(NULL,tf,barNo)-iHigh(NULL,tf,barNo+1));
		case 4:
			return(iLow(NULL,tf,barNo)-iLow(NULL,tf,barNo+1));
		case 5:
			return((iHigh(NULL,tf,barNo)+iLow(NULL,tf,barNo)-iHigh(NULL,tf,barNo+1)-iLow(NULL,tf,barNo+1))/2);
		case 6:
			return((iHigh(NULL,tf,barNo)+iLow(NULL,tf,barNo)+iClose(NULL,tf,barNo)-iHigh(NULL,tf,barNo+1)-iLow(NULL,tf,barNo+1)-iClose(NULL,tf,barNo+1))/3);
		case 7:
			return((iHigh(NULL,tf,barNo)+iLow(NULL,tf,barNo)+iClose(NULL,tf,barNo)+iOpen(NULL,tf,barNo)-iHigh(NULL,tf,barNo+1)-iLow(NULL,tf,barNo+1)-iClose(NULL,tf,barNo+1)-iOpen(NULL,tf,barNo+1))/4);
		case 8:
			return((iHigh(NULL,tf,barNo)+iLow(NULL,tf,barNo)+iClose(NULL,tf,barNo)+iClose(NULL,tf,barNo)-iHigh(NULL,tf,barNo+1)-iLow(NULL,tf,barNo+1)-iClose(NULL,tf,barNo+1)-iClose(NULL,tf,barNo+1))/4);
		
		case 9:
			return (iMA(NULL,tf,3,0,MODE_SMA,PRICE_MEDIAN,barNo)-iMA(NULL,tf,3,0,MODE_SMA,PRICE_MEDIAN,barNo+1));
		case 11:
			//   0 
			return(getAccMAValue(barNo,tf));

		default:
			return((iHigh(NULL,tf,barNo)+iLow(NULL,tf,barNo)+iClose(NULL,tf,barNo)+iOpen(NULL,tf,barNo)-iHigh(NULL,tf,barNo+1)-iLow(NULL,tf,barNo+1)-iClose(NULL,tf,barNo+1)-iOpen(NULL,tf,barNo+1))/4);
	}
}
//    1
double calcAcceleration(int barNo, int tf=PERIOD_M1){
	if(spPriceType<10)return(calcSpeed(barNo)-calcSpeed(barNo+1));
	else{
		switch(spPriceType){
			case 11:
				return(getAccMAValue(barNo,tf));
			case 12:
				return(getAccLRValue(barNo,tf));
			case 13:
				return(getAccLRZZValue(barNo,tf));
		}
	}
}
//        ,
//   ,    ..
void processNewBar(int counted_bars){
	//   
	lastTrendStart++;
	lastExtremumBar++;
	//  
	for(int i=Bars-counted_bars; i>0; i--){
		fiboZeroLevel[i]=0;
		fiboFullLevel[i]=0;
	}
	//  
	//arrayShiftD(zzM1,0);
	//arrayShiftD(zzM1L,0);
	//arrayShiftD(zzM1H,0);
	calculateZZ(PERIOD_M1, zzM1, zzM1L, zzM1H, zzPeriod, 2, 0);
	//  ,  
	if(drawObjects)shiftFibos();
}
void arrayShiftD(double& arr[], double v=0){
	for(int i=ArraySize(arr)-1; i>0; i--){
		arr[i]=arr[i-1];
	}
	arr[0]=v;
}

//       1 ,  ,   
// 
void shiftFibos(){
	arrayShiftI(fiboIndex,0);
	for(int i=0; i<ArraySize(fiboIndex); i++)if(fiboIndex[i]>0)fiboIndex[i]=fiboIndex[i]+1;
	/*int count=0;
	for(int i=0; i<ArraySize(fiboIndex); i++){
		if(fiboIndex[i]>0){
			count++;
			string name="cmd_fibo_"+fiboIndex[i];
			if(ObjectFind(name)>-1)ObjectDelete(name);
			else continue;
			if(fiboCount>0 && count>fiboCount){
				// , 
				//    
				break;
			}else{
				//   , ..    
				fiboIndex[i]=fiboIndex[i]+1;
				if(outputType=="f")drawFibo(fiboIndex[i],fiboIndex[i],level0[fiboIndex[i]],level100[fiboIndex[i]]);
				else if(outputType=="p")drawFiboPoints(fiboIndex[i],level0[fiboIndex[i]],level100[fiboIndex[i]],4);
			}
		}
	}*/
}
void deleteObjects(){
	string txt;

	for(int i=ObjectsTotal(); i>=0; i--){
		txt=ObjectName(i);
		if(StringFind(txt,"cmd_fibo_")>-1)ObjectDelete(txt);
	}
}
void arrayShiftI(int& arr[], int v=0){
	for(int i=ArraySize(arr)-1; i>0; i--){
		arr[i]=arr[i-1];
	}
	arr[0]=v;
}
//         
double getZZValue(int barNo, int tf=0){
	return(zzM1[barNo]);
}
//    dex_Angle_MA_v3     
double getAngleMAValue(int barNo, int tf=0){
	//if(tf=PERIOD_M1)return (iCustom(NULL,tf,"dex_Angle_MA_v3",dex_MA_Period,dex_MA_Method,dex_MA_Price,0,barNo));
	return (iCustom(NULL,tf,"dex_Angle_MA_v3",2,0,0,0,barNo));
}
double getAccMAValue(int barNo, int tf=0){
	if(tf==PERIOD_M1)return(iCustom(NULL,tf,"Acc&MAfixed",4,1000,1000,1,barNo));
	return(iCustom(NULL,tf,"Acc&MAfixed",4,1000,1000,1,barNo));
}
double getAccLRValue(int barNo, int tf=0){
	return(iCustom(NULL,tf,"Acc&LR",LRPeriod+Period(),LRPrice,0,barNo));
}
double getAccLRZZValue(int barNo, int tf=0){
	int p=LRzzPeriod;
	if(tf!=PERIOD_M1){
		p=p/Period();
		barNo=convertBarNo(barNo,tf,PERIOD_M1);
	}
	//return(iCustom(NULL,tf,"Acc&LR&ZZ",LRPeriod,LRPrice,LRzzPeriod,0,barNo));
	return(iCustom(NULL,tf,"Acc&LR&ZZ",LRPeriod,LRPrice,p,0,barNo));
}

//+------------------------------------------------------------------+