//+------------------------------------------------------------------+
//|                                                iZoneDetector.mq4 |
//|                                         Copyright  2009, Camper |
//|                                        http://www.aboutcamper.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Camper"
#property link      "http://www.aboutcamper.ru"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 CLR_NONE
#property indicator_color2 CLR_NONE
#property indicator_color3 Red
#property indicator_color4 Cyan

#include <cmdfunc.mqh>
#include <cmdfibos.mqh>
#include <indicators.mqh>

// 
extern string a="  ";
extern int zoneDeviation=1;				//            
extern string b="    ";
extern int peakDeviation=5;				//     
extern string c=" ,     ,      ";
extern int barsDeviation=5;				//  ,     ,    
//extern int zonePeaks=4;						//      
extern string d="    ";
extern int minZoneLen=3;					//     
extern string e="    ";
extern int maxZoneLen=20;					//     .       :)
extern string f=" dex_Angle_MA   -";
extern int dexMAPeriod=3;
extern int dexMAMethod=0;
extern int dexMAPrice=0;
string debugFrom="2010.03.26 18:55";
string debugTo="2010.03.24 08:25";


int max_bars=500;

//---- buffers
double zoneHigh[], zoneLow[], fibo0[], fibo100[];


//  
string selfName="iZD";
double dexAngleMA[];							//  

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
//---- 
	selfName=selfName+":"+zoneDeviation+"/"+peakDeviation+"/"+barsDeviation+"/"+minZoneLen+"/"+maxZoneLen+"/"+dexMAPeriod+"/"+dexMAMethod+"/"+dexMAPrice;
	Print(selfName+" started");
	SetIndexBuffer(0,fibo0);
	SetIndexEmptyValue(0,0.0);
	SetIndexBuffer(1,fibo100);
	SetIndexEmptyValue(1,0.0);

	SetIndexStyle(2,DRAW_ARROW);
	SetIndexBuffer(2,zoneLow);
	SetIndexEmptyValue(2,0.0);
	SetIndexStyle(3,DRAW_ARROW);
	SetIndexBuffer(3,zoneHigh);
	SetIndexEmptyValue(3,0.0);
	
	//ArrayInitialize(zoneLow,0);
	//ArrayInitialize(zoneHigh,0);
	ArrayResize(dexAngleMA,max_bars*Period());
	
//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit(){
//----
	deleteObjects();
//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
	int    counted_bars=IndicatorCounted();
	int limit=Bars-counted_bars;
	int zoneIndex,i=0,j,ih,il;
	if(limit>max_bars)limit=max_bars;

	defineNewBar();
	//    ,     
	if(is_newbar)processNewBar(counted_bars);

	double h,l;
	while(i<limit){
		i++;
		zoneIndex=detectZone(i,h,l);
		if(zoneIndex>-1){
			//    
			if(zoneLow[zoneIndex]!=0 && zoneLow[zoneIndex]!=l){
				j=zoneIndex;
				while(zoneLow[j]!=0){
					zoneLow[j]=0;
					zoneHigh[j]=0;
					j++;
				}
			}
			//  , 
			//   
			ih=getZoneValueIndex(zoneIndex,i,MODE_HIGH);
			h=High[ih];
			il=getZoneValueIndex(zoneIndex,i,MODE_LOW);
			l=Low[il];
			for(j=i; j<=zoneIndex; j++){
				zoneLow[j]=l;
				zoneHigh[j]=h;
			}
			//    
			// 
			makePrognoze(il,OP_BUY,l);
			// 
			makePrognoze(ih,OP_SELL,h);
			i=zoneIndex;
		}
	}
	return(0);
}
int detectZone(int from, double& high, double& low){
	bool isLowBound=false, isHighBound=false, hit;
	int zoneIndex=-1, delta=0, t;
	high=High[from]; low=Low[from];
	//high=0; low=0;
	for(int i=from; i<from+maxZoneLen; i++){
		hit=false;
		//if(Time[from]==StrToTime(debugFrom))Print(i+" ["+TimeToStr(Time[i])+"]: h="+high+", l="+low+", H[i]="+High[i]+", L[i]="+Low[i]);
		//          -    ,    
		t=hasEquals(High[i],i-1,from+1,MODE_HIGH);
		if(t>-1){
			//if(Time[from]==StrToTime(debugFrom))Print(High[i]+" has hit on "+t);
			//     
			isHighBound=true;
			high=High[i];
			zoneIndex=i;
			delta=0;
			hit=true;
		}
		t=hasEquals(Low[i],i-1,from+1,MODE_LOW);
		if(t>-1){
			//if(Time[from]==StrToTime(debugFrom))Print(Low[i]+" has hit on "+t);
			//
			isLowBound=true;
			low=Low[i];
			zoneIndex=i;
			delta=0;
			hit=true;
		}
		//       ,      -  
		if(!hit){
			//    
			if(MathAbs(High[i]-high)/Point>peakDeviation || MathAbs(low-Low[i])/Point>peakDeviation)break;
			//       
			if(High[i]<low || Low[i]>high)break;
			delta++;
		}
		if(delta>barsDeviation)break;
	}
	//if(Time[from]==StrToTime(debugFrom))Print("idx="+zoneIndex);
	if((isLowBound || isHighBound) && zoneIndex-from>=minZoneLen){
		//   
		//if(!isHighBound){
			//    ,      - 
			high=High[iHighest(NULL,0,MODE_HIGH,zoneIndex-from,from)];
		//}
		//if(!isLowBound){
			//   
			low=Low[iLowest(NULL,0,MODE_HIGH,zoneIndex-from,from)];
		//}
		//if(Time[from]==StrToTime(debugFrom))Print("Zone at "+zoneIndex+": h="+high+", l="+low);
		return(zoneIndex);
	}
	else return(-1);
}
//          
void makePrognoze(int index, int direction, double startPrice){
	//       1
	double currentPrice,vel0,vel1,acc=0;
	int i,m;
	//   -  ,   =0
	int barNo=convertBarNo(index,PERIOD_M1);
	m=barNo;
	
	string temp="fibo0 on "+TimeToStr(iTime(NULL,PERIOD_M1,barNo))+" = "+startPrice+", ";
	
	//   ,     
	double price;
	if(direction==OP_BUY)price=iLow(NULL,PERIOD_M1,barNo);
	else price=iHigh(NULL,PERIOD_M1,barNo);
	while(price!=startPrice){
		barNo--;
		if(direction==OP_BUY)price=iLow(NULL,PERIOD_M1,barNo);
		else price=iHigh(NULL,PERIOD_M1,barNo);
	}
	//     :   
	while(price==startPrice){
		barNo--;
		if(direction==OP_BUY)price=iLow(NULL,PERIOD_M1,barNo);
		else price=iHigh(NULL,PERIOD_M1,barNo);
	}
		
	//    ,   ,    
	// ,               -       
	if(direction==OP_BUY && price<startPrice)return(0);
	if(direction==OP_SELL && price>startPrice)return(0);
	for(i=barNo; i>0; i--){
		if(direction==OP_BUY && getAngleMA(i)<=getAngleMA(i-1)){
			//temp=temp+", 1="+getAngleMA(i)+", 0="+getAngleMA(i-1);
			barNo=i;
			break;
		}
		if(direction==OP_SELL && getAngleMA(i)>=getAngleMA(i-1)){
			//temp=temp+", 1="+getAngleMA(i)+", 0="+getAngleMA(i-1);
			barNo=i;
			break;
		}
	}
	//Print(temp+", after: "+barNo);
	
	//  ,   ,   
	//     23%
	//    
	currentPrice=(iHigh(NULL,PERIOD_M1,barNo)+iLow(NULL,PERIOD_M1,barNo)+iClose(NULL,PERIOD_M1,barNo)+iClose(NULL,PERIOD_M1,barNo))/4;
	temp=temp+"fibo23 on "+TimeToStr(iTime(NULL,PERIOD_M1,barNo))+" = "+currentPrice;
	//if(Time[index]==StrToTime(debugFrom))Print(temp);
	currentPrice=startPrice+(currentPrice-startPrice)/fiboSecondLevel;
	barNo=convertBarNo(barNo,0,PERIOD_M1);
	drawFibo(barNo, barNo, startPrice, currentPrice);
	//    
	fibo0[barNo]=startPrice;
	fibo100[barNo]=currentPrice;
}
int hasEquals(double price, int from, int to, int mode){
	for(int i=from; i>=to; i--){
		if(mode==MODE_HIGH && price==High[i])return(i);
		if(mode==MODE_LOW && price==Low[i])return(i);
	}
	return(-1);
}
int getZoneValueIndex(int from, int to, int mode){
	//     
	double v[1];
	double base,current;
	if(mode==MODE_HIGH){
		v[0]=High[from];
		base=High[iLowest(NULL,0,MODE_HIGH,from-to,to)];
	}
	if(mode==MODE_LOW){
		v[0]=Low[from];
		base=Low[iHighest(NULL,0,MODE_LOW,from-to,to)];
	}
	//     . 
	int bars[1]={1},count=1,index;
	//     
	//   __ ,  ,     .
	//      (  0)  ,       v[]
	int indices[1]; indices[0]=from;
	string s="";
	bool matched=false;
	//    
	//Print("Searching from "+from+" to "+to);
	for(int i=from-1; i>=to; i--){
		matched=false;
		if(mode==MODE_HIGH)current=High[i];
		if(mode==MODE_LOW)current=Low[i];
		for(int j=0; j<count; j++)if(v[j]==current){
			//     ,  
			if(mode==MODE_HIGH)bars[j]=bars[j]+(High[i]-base)/Point;
			if(mode==MODE_LOW)bars[j]=bars[j]+(base-Low[i])/Point;
			indices[j]=i;
			matched=true;	//      
		}
		//      -   
		if(!matched){
			count++;
			ArrayResize(v,count);
			ArrayResize(bars,count);
			ArrayResize(indices,count);
			v[count-1]=current;
			bars[count-1]=1;
			indices[count-1]=i;
		}
	}
	//     
	index=ArrayMaximum(bars);
	//        
	return(indices[index]);
}
//      
//      1,   
double getAngleMA(int barNo){
	return(dexAngleMA[barNo]);
}
//  true,  :
// -      
// -    
bool isInRange(double price, double base){
	return(MathAbs(base-price)/Point <= zoneDeviation);
}
void deleteObjects(){
	string txt;

	for(int i=ObjectsTotal(); i>=0; i--){
		txt=ObjectName(i);
		if(StringFind(txt,"cmd_fibo_")>-1)ObjectDelete(txt);
	}
}
void processNewBar(int counted_bars){
	Print("calc dex");
	calculateAngleMA(PERIOD_M1, dexAngleMA, dexMAPeriod, dexMAMethod, dexMAPrice, 0);
	Print("end calc dex");
}
//+------------------------------------------------------------------+